import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import controlP5.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class chroma_equalizer_rand_spec_export extends PApplet {




ControlP5 cp5;


//===== size 1050 x 800. h(bars)=550, h(score and play)=450, h(footer)=50.

float d=150; // bar width
float h=550; // bar height
int num=7; // number of bars
int num2=num*num; // num to the power of 2
float xx; // x of new bar created by click


//===== colors

int c;  // lerp of left and right
int cl; // color on the left
int cr; // color on the right
int a, b; // x values for the first and the last bar

int cw=color(255);
int c1;

// color array checking
int [] cs = new int[num]; // scanning colors on the screen
int [] test = new int[num2]; // self-comparison results array
float rr1, gg1, bb1, rr2, gg2, bb2; // rgb values twice from the same array
float di; // distance between colors
float thr0=20; // threshold 0
float thr1=5; // threshold 1
float thr2=0; // threshold 2
float thr; // major threshold
int sum1;

// random seed
int seed;
float seed2;

//initial color gray
int ci=color(200);



//===== score

PFont font; // font for score
PFont arial; // font for game ID

int count; // click counts
String score; // main counter
float sq=75; // score fields size

int count1; //
String score1; //
int count2; //
String score2; //
int count3; //
String score3; //

int ccount; // count changes when threshold changes


//===== buttons and footer

PImage play;
PImage newgame;
PImage footer;

PImage rand;
PImage spec;
PImage rands;
PImage specs;


//===== begin the game
int ng;


//===== sound







//===========================================================================




public void setup(){


background(255);

// initial count
count=0;

//threshold count
ccount=0;

//score
font = loadFont("GothamRounded-Book-24.vlw");

// game ID font
arial = createFont("arial", 12);

// initial blank bars
noStroke();
fill(200);
rectMode(CORNER);
rect(0, 0, width, h);
  for(int x=1; x<num; x++){
  stroke(255);
  line(x*d, 0, x*d, h);
  }
  for(int x=1; x<num; x++){
  stroke(200);
  line(x*d, h+5, x*d, h+15);
  }
  
//images
play=loadImage("play.png");
newgame=loadImage("newgame.png");
footer=loadImage("footer.png");

rand=loadImage("rand.png");
spec=loadImage("spec.png");
rands=loadImage("rand-s.png");
specs=loadImage("spec-s.png");


image(rands, (d*6)-(sq/2), 618);
image(specs, (d*6)-(sq/2), 661);


//initial game state before play is clicked
ng=0;




// input field
cp5 = new ControlP5(this);
  fill(0);
   cp5.addTextfield("input")
     .setPosition(752, 661)
     .setSize(97, 32)
     .setFont(createFont("arial", 12))
     .setAutoClear(false)
     .setColorBackground(color(255))
     .setColorForeground(color(200)) //Qty & rim color
     .setColorValue(color(0)) // Text inside control or box
     .setColorLabel(color(255, 0))  //Text Color
     .setColorActive(color(75)) //Selected items
     .setText("   ")
     .setInputFilter(ControlP5.INTEGER)
     ;

}






//===========================================================================




public void draw(){
  
// scanning color bars
  for(int x=0; x<num; x++){
    cs[x] = get(PApplet.parseInt((x*d)+(d/2)), 10); // get Y coordinate is any number bellow h
  }
  
  
  
  
    if(ccount==0){
     thr=thr0; 
    }
    if(ccount==1){
     thr=thr1; 
    }
    if(ccount==2){
     thr=thr2; 
    }
    
    
    
  
  
  
  
// scanned bars comapred to themselves. test array stores results of comparison. if same 1, 2 or 3, if not 0. 
  for(int y=0; y<num; y++){
    for(int x=0; x<num; x++){
       
          //rgb values 1
          rr1=red(cs[y]);
          gg1=green(cs[y]);
          bb1=blue(cs[y]);
          
          //rgb values 1
          rr2=red(cs[x]);
          gg2=green(cs[x]);
          bb2=blue(cs[x]);
          
          //3D distance between colors
          di=dist(rr1, gg1, bb1, rr2, gg2, bb2);
  
          if(di<=thr){ // distance lower than threshold
            test[x+(y*num)]=1; 
          }
          else {
            test[x+(y*num)]=0; 
          }

  }
    }


// sum of all the elements in the comparison results test array
int  sum=0; // declare and initialize in draw as local variable every time draw is looped
// adding up all elements in the test array
  for(int x=0; x<(num2); x++){
    sum=sum+test[x]; 
  }
  
    sum1=sum;
    
    

  
//using sum results to show three scores.

  textFont(font);
  textSize(32);
  textAlign(CENTER, CENTER);

  if(ng!=0){ // if play is clicked
  rectMode(CENTER);
    if(sum1==num2 && ccount==0){ // first score. first threshold
      fill(170);
      rect(3*d, 655, sq, sq);
      fill(0);
      noStroke();
      score1 = str(count1);
      text(score1, 3*d, 655);
      
      
      
    }
    if (sum1==num2 && ccount==1){ // second score. second threshold
    
      fill(85);
      rect(width/2, 655, sq, sq);
      fill(0);
      noStroke();
      score2 = str(count2);
      text(score2, width/2, 655);
    }
    if(sum1==num2 && ccount==2){ // final score. if the colors are exactly the same
      fill(0);
      rect(4*d, 655, sq, sq);  
      fill(255);
      noStroke();
      score3 = str(count3);
      text(score3, 4*d, 655);
    }

  }
  
  // score numbers
     
     //first score number
     //if(sum1>=num2 && count>0){
     //fill(0);
     //noStroke();
     //score1 = str(count1);
     //text(score1, 3*d, 655);
     //}
     
     ////second score number
     //if(sum1>=num2*2 && count>0){
     //fill(0);
     //noStroke();
     //score2 = str(count2);
     //text(score2, width/2, 655);
     //}
     
     ////third score number
     //if(sum1>=num2*3 && count>0){
     //fill(255);
     //noStroke();
     //score3 = str(count3);
     //text(score3, 4*d, 655);
     //}


  
// main score counter
rectMode(CENTER);
fill(0);
rect(d, 655, sq, sq);
fill(255);
rect(d, 655, sq-6, sq-6);
// score  
fill(0);
noStroke();
score = str(count);
text(score, d, 655);

// mask for the main score counter
if(ng==0){ // if the game didnt start yet
  fill(255);
}
if(ng==1 || ng==2){ // if clicked on either of the buttons
  fill(255, 0);
}
noStroke();
rect(d, 655, sq+5, sq+5);



//footer
image(footer, 0, height-50);


// cursors
  if(mouseY<=h){
    cursor(CROSS);
  }
  else if((mouseX>=(d*6)-(sq/2) && mouseX<(d*6)+(sq/2)) && (mouseY>=618 && mouseY<=618+32)){
    cursor(HAND); // rand
  }
  else if((mouseX>=(d*6)-(sq/2) && mouseX<(d*6)+(sq/2)) && (mouseY>=618+32+11 && mouseY<=618+75)){
    cursor(HAND); // spec
  }
  else{
    cursor(ARROW);
  }
  
  // get input value
 seed2 = PApplet.parseFloat(cp5.get(Textfield.class,"input").getText());
 
 
 // show RAND generated ID mask
  noStroke();
  fill(255);
  rect(800, 633, 100, 35);
 
 
  // show RAND generated ID
  textFont(arial);
  textAlign(LEFT, CENTER);
  textSize(12);
  if(ng==1){
  fill(0);
  }
  else{
    fill(255);
  }
  text(str(seed), 762, 633);
  
  
  // mask for the input field when rand is clicked
  //stroke(0);
 
  //if(ng==1){
  // fill(255); 
  //}
  //else
  //{
  //  fill(255, 0);
  //}
  //rect(753, 662, 96, 31);

  



//printArray(test);
//println("sum1:  "+sum1);
//println("switch count "+ccount);
//println("threshold "+thr);

//println("count "+count);
//println("count1 "+count1);
//println("count2 "+count2);
//println("count3 "+count3);

  
}




//===========================================================================




public void mousePressed(){
  
//===== click RAND
  if((mouseX>=(d*6)-(sq/2) && mouseX<(d*6)+(sq/2)) && (mouseY>=618 && mouseY<=618+32)){
    ng=1;
    seed=PApplet.parseInt(random(1000000));  
    randomSeed(seed);
    ccount=0;
    
// initial colors
    rectMode(CORNER);
    for(int x=0; x<num; x++){
      noStroke();
      fill(random(255), random(255), random(255));
      rect(x*d, 0, d, h);
    }
    
    //image(newgame, (d*6)-(sq/2), 618);
    count=0;
    count1=0;
    count2=0;
    count3=0;
    
    //reset mask for scores
    fill(255);
    rect(2*d, h+16, 3*d, d);
    
    
    image(rand, (d*6)-(sq/2), 618);
    image(specs, (d*6)-(sq/2), 661);

    

    
  }
  
  
  //===== click SPEC
  if((mouseX>=(d*6)-(sq/2) && mouseX<(d*6)+(sq/2)) && (mouseY>=618+32+11 && mouseY<=618+75)){
    ng=2;  
    randomSeed(PApplet.parseInt(seed2));
    ccount=0;
    
// initial colors
    rectMode(CORNER);
    for(int x=0; x<num; x++){
      noStroke();
      fill(random(255), random(255), random(255));
      rect(x*d, 0, d, h);
    }
    
    //image(newgame, (d*6)-(sq/2), 618);
    count=0;
    count1=0;
    count2=0;
    count3=0;
    
    //reset mask for scores
    fill(255);
    rect(2*d, h+16, 3*d, d);
    

    image(spec, (d*6)-(sq/2), 661);
    image(rands, (d*6)-(sq/2), 618);
    
  }
  
  

  
//===== playing the game 
  if(mouseY>=0 && mouseY<=h){
  if(ng!=0){ // if game hasn't started yet
  
  
  
  c1=get(PApplet.parseInt((3*d)+2), 657);
  
  if(sum1 == num2){
      
     ccount=ccount+1; 
    }
    
    
  

// pick colors
    a=PApplet.parseInt(mouseX+((num-1)*d));
    b=PApplet.parseInt(mouseX-((num-1)*d)); 

    if(mouseX<d){
      cl=get(a, mouseY);  
      cr=get(PApplet.parseInt(mouseX+d), mouseY);  
    }
    else if (mouseX>(num-1)*d){
      cl=get(PApplet.parseInt(mouseX-d), mouseY);
      cr=get(b, mouseY); 
  
    }
    else{
      cl=get(PApplet.parseInt(mouseX-d), mouseY);
      cr=get(PApplet.parseInt(mouseX+d), mouseY);
    }  
  
// lerp color
    c=lerpColor(cl, cr, 0.5f);
  
  
// calculating position of bars
    if(mouseX>=0 && mouseX<d){
    xx=0;
    }
    else if(mouseX>=d){
    xx=mouseX-(mouseX%d);
    }
  
    fill(c);
    noStroke();
    rectMode(CORNER);
    rect(xx, 0, d, h);
  
    //total count the clicks
    if(ccount>=3){
      count=count+0;
    
    }
    else
    {
     count=count+1;
    }
    
    
    //score 1
    if(ccount<1){
    count1=count1+1;
    }
    else
    {
     count1=count1+0; 
    }
    
    //score 2
    if(ccount<2){
    count2=count2+1;
    }
    else
    {
     count2=count2+0; 
    }
    
    
    //score 3
    if(ccount<3){
    count3=count3+1;
    }
    else
    {
     count3=count3+0; 
    }
    
 
    



  } 
  }
  
  
  
}



// ======================= screenshot

public void keyPressed(){
  if(key=='s' || key=='S'){
    String p = str(seed) + ".png";
  saveFrame(p);
  }
}


  
  
  
  
  
  public void settings() { 
size(1050, 800); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "chroma_equalizer_rand_spec_export" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
